#include <map>

using namespace std;

map<string, string> type_map;
void init_map(){
type_map [ "POS " ] = "Coordinates";
type_map [ "VEL " ] = "Velocities";
type_map [ "ID  " ] = "ParticleIDs";
type_map [ "MASS" ] = "Masses";
type_map [ "U   " ] = "InternalEnergy";
type_map [ "RHO " ] = "Density";
type_map [ "NE  " ] = "ElectronAbundance";
type_map [ "NH  " ] = "NeutralHydrogenAbundance";
type_map [ "RADG" ] = "RADGAMMA";
type_map [ "RADA" ] = "RAD_ACCEL";
type_map [ "HII " ] = "HII";
type_map [ "HeI " ] = "HeI";
type_map [ "HeII" ] = "HeII";
type_map [ "He3 " ] = "HeIII";
type_map [ "H2I " ] = "H2I";
type_map [ "H2II" ] = "H2II";
type_map [ "HM  " ] = "HM";
type_map [ "HD  " ] = "HD";
type_map [ "DI  " ] = "DI";
type_map [ "DII " ] = "DII";
type_map [ "HeHp" ] = "HeHp";
type_map [ "DETI" ] = "DelayTime";
type_map [ "HSML" ] = "SmoothingLength";
type_map [ "VALP" ] = "ArtificialViscosityV";
type_map [ "SFR " ] = "StarFormationRate";
type_map [ "AGE " ] = "StellarFormationTime";
type_map [ "HSMS" ] = "StellarSmoothingLength";
type_map [ "ACRS" ] = "StellarSpreadingLength";
type_map [ "Z   " ] = "Metallicity";
type_map [ "POT " ] = "Potential";
type_map [ "ACCE" ] = "Acceleration";
type_map [ "ENDT" ] = "RateOfChangeOfEntropy";
type_map [ "STRD" ] = "DiagonalStressTensor";
type_map [ "STRO" ] = "OffDiagonalStressTensor";
type_map [ "STRB" ] = "BulkStressTensor";
type_map [ "SHCO" ] = "ShearCoefficient";
type_map [ "TSTP" ] = "TimeStep";
type_map [ "BFLD" ] = "MagneticField";
type_map [ "BFSM" ] = "SmoothedMagneticField";
type_map [ "DBDT" ] = "RateOfChangeOfMagneticField";
type_map [ "VRMS" ] = "RMSVelocity";
type_map [ "VBLK" ] = "BulkVelocity";
type_map [ "VRAD" ] = "RMSRadialVelocity";
type_map [ "VTAN" ] = "RMSTangentialVelocity";
type_map [ "TNGB" ] = "TrueNumberOfNeighbours";
type_map [ "DPP " ] = "MagnetosReaccCoefficient";
type_map [ "VDIV" ] = "VelocityDivergence";
type_map [ "VROT" ] = "VelocityCurl";
type_map [ "VORT" ] = "Vorticity";
type_map [ "DIVB" ] = "DivergenceOfMagneticField";
type_map [ "ABVC" ] = "ArtificialViscosity";
type_map [ "AMDC" ] = "ArtificialMagneticDissipatio";
type_map [ "ADYN" ] = "AlfaDynamo";
type_map [ "EDYN" ] = "EtaDynamo";
type_map [ "PHI " ] = "DivBcleaningFunctionPhi";
type_map [ "XPHI" ] = "ColdGasFraction_PHI";
type_map [ "GPHI" ] = "DivBcleaningFunctionGadPhi";
type_map [ "ROTB" ] = "RotationB";
type_map [ "SRTB" ] = "SmoothedRotationB";
type_map [ "EULA" ] = "EulerPotentialA";
type_map [ "EULB" ] = "EulerPotentialB";
type_map [ "COOR" ] = "CoolingRate";
type_map [ "CONR" ] = "ConductionRate";
type_map [ "DENN" ] = "Denn";
type_map [ "EGYP" ] = "EnergyReservoirForFeeback";
type_map [ "EGYC" ] = "EnergyReservoirForColdPhase";
type_map [ "CRC0" ] = "CR_C0";
type_map [ "CRQ0" ] = "CR_q0";
type_map [ "CRP0" ] = "CR_P0";
type_map [ "CRE0" ] = "CR_E0";
type_map [ "CRn0" ] = "CR_n0";
type_map [ "CRco" ] = "CR_ThermalizationTime";
type_map [ "CRdi" ] = "CR_DissipationTime";
type_map [ "BHMA" ] = "BH_Mass";
type_map [ "ACRB" ] = "BH_AccreationLength";
type_map [ "BHMD" ] = "BH_Mdot";
type_map [ "BHPC" ] = "BH_NProgs";
type_map [ "BHMB" ] = "BH_Mass_bubbles";
type_map [ "BHMI" ] = "BH_Mass_ini";
type_map [ "BHMR" ] = "BH_Mass_radio";
type_map [ "MACH" ] = "MachNumber";
type_map [ "SHSP" ] = "ShockSpeed";
type_map [ "SHCP" ] = "ShockCompressionRatio";
type_map [ "SHNR" ] = "ShockNormal";
type_map [ "DTEG" ] = "DtEnergy";
type_map [ "PSCS" ] = "Preshock_SoundSpeed";
type_map [ "PSDE" ] = "Preshock_Density";
type_map [ "PSEN" ] = "Preshock_Energy";
type_map [ "PSXC" ] = "Preshock_XCR";
type_map [ "DJMP" ] = "DensityJump";
type_map [ "EJMP" ] = "EnergyJump";
type_map [ "CRDE" ] = "CR_DtE";
type_map [ "TIPS" ] = "TidalTensorPS";
type_map [ "DIPS" ] = "DistortionTensorPS";
type_map [ "CACO" ] = "CausticCounter";
type_map [ "FLDE" ] = "FlowDeterminant";
type_map [ "STDE" ] = "StreamDensity";
type_map [ "SOMA" ] = "SECONDORDERMASS";
type_map [ "PSDE" ] = "PhaseSpaceDensity";
type_map [ "ANRA" ] = "AnnihilationRadiation";
type_map [ "LACA" ] = "LastCaustic";
type_map [ "SHOR" ] = "SheetOrientation";
type_map [ "INDE" ] = "InitDensity";
type_map [ "TEMP" ] = "Temperature";
type_map [ "XNUC" ] = "EOSXNUC";
type_map [ "P   " ] = "Pressure";
type_map [ "ET" ] = "EddingtonTensor";
type_map [ "PTSU" ] = "PSum";
type_map [ "DMNB" ] = "DMNumNgb";
type_map [ "NTSC" ] = "NumTotalScatter";
type_map [ "SHSM" ] = "SIDMHsml";
type_map [ "SRHO" ] = "SIDMRho";
type_map [ "SVEL" ] = "SVelDisp";
type_map [ "DMHS" ] = "DMHSML";
type_map [ "DMDE" ] = "DMDENSITY";
type_map [ "DMVD" ] = "DMVELDISP";
type_map [ "VDMH" ] = "DMHSML_V";
type_map [ "VDMD" ] = "DMDENSITY_V";
type_map [ "Zs  " ] = "Zs";
type_map [ "ZAge" ] = "ZAGE";
type_map [ "ZAlv" ] = "ZAGE_LLV";
type_map [ "iM  " ] = "SSPInitialMass";
type_map [ "CLDX" ] = "CloudFraction";
type_map [ "HOTT" ] = "HotPhaseTemperature";
type_map [ "TEMP" ] = "Temperature";
type_map [ "TRCK" ] = "TrackContributes";
type_map [ "ZsMT" ] = "ZSMOOTH";
type_map [ "ZSMT" ] = "allZSMOOTH";
type_map [ "DABN" ] = "ABUNDANCE";
type_map [ "DABG" ] = "ABND_GRAD";
type_map [ "DABS" ] = "ABND_SPH";
type_map [ "DCFB" ] = "DIFFUSING_CB";
type_map [ "DCFA" ] = "DIFFUSING_CA";
type_map [ "DCFD" ] = "DIFFUSING_CD";
type_map [ "DTST" ] = "DIFF_TSTEP";
type_map [ "CHEM" ] = "ChemicalAbundances";
type_map [ "CRpN" ] = "BPCRpNormalization";
type_map [ "CReN" ] = "BPCReNormalization";
type_map [ "CRpS" ] = "BPCRpSlope";
type_map [ "CReS" ] = "BPCReSlope";
type_map [ "CRpE" ] = "BPCRpEnergy";
type_map [ "CRpN" ] = "BPCRpNumber";
type_map [ "CRpP" ] = "BPCRpPressure";
type_map [ "CReP" ] = "BPCRePressure";
type_map [ "AGSH" ] = "AGS_SOFT";
type_map [ "AGSD" ] = "AGS_DENS";
type_map [ "AGSZ" ] = "AGS_ZETA";
type_map [ "AGSO" ] = "AGS_OMEGA";
type_map [ "AGSC" ] = "AGS_CORR";
type_map [ "AGSN" ] = "AGS_NGBS";
type_map [ "VSDI" ] = "TurbulenceDissipation";
type_map [ "VSDR" ] = "TurbulenceDriving";
type_map [ "MGPH" ] = "ModifiedGravityPhi";
type_map [ "MGAC" ] = "ModifiedGravityAcceleration";
return;
}
