/**
 * Not Implemented...  
 *
 */



#include "gadgetreader.h"

using namespace std;

DataReader::DataReader(int format, bool swap, bool lgadget, bool verbose){
    format_ = format;
    swap_ = swap;
    lgadget_ = lgadget;
    verbose_ = verbose;
}



DataReader::~DataReader(){
    
    /* free temporary storage again */
    free(gadget.np[0]);
    free(gadget.np[1]);
    free(gadget.np[2]);
    free(gadget.np[3]);
    free(gadget.np[4]);
    free(gadget.np[5]);
}


bool DataReader::setFile(string dataFileName){
    char    infile_name[MAXSTRING];
    char    gadget_file[MAXSTRING];
    int     no_gadget_files, i_gadget_file;
    FILE   *icfile;
    int     ipart;
    
    strcpy(infile_name, dataFileName.c_str());

    
    // DEBUG
    if(verbose_){
        fprintf(stderr,"=====================================================\n");
        fprintf(stderr," read_gadget:\n\n");
        fprintf(stderr,"    infile = %s\n",infile_name);
        fprintf(stderr,"    format = %d\n",format_);
        fprintf(stderr,"    swap   = %d\n",swap_);
        fprintf(stderr,"=====================================================\n");
    }
    
    /*==================================
     * are there multiple GADGET files?
     *==================================*/
    if((icfile = fopen(infile_name,"rb")) == NULL)
    {
        /* maybe there are multiple GADGET files ... count them! */
        no_gadget_files = 0;
        i_gadget_file   = 0;
        sprintf(gadget_file,"%s.%d",infile_name,i_gadget_file);
        while((icfile = fopen(gadget_file, "rb")) != NULL)
        {
            fclose(icfile);
            no_gadget_files++;
            i_gadget_file++;
            sprintf(gadget_file,"%s.%d",infile_name,i_gadget_file);
        }
        
        if(no_gadget_files > 1)
        {
            
            //DEBUG
            if(verbose_){
                fprintf(stderr,"\nreading GADGET data from %d files:\n",no_gadget_files);
            }
            
            gadget_.no_gadget_files  = no_gadget_files;
            
            /* allocate temporary storage for no. of particles arrays */
            gadget_.np[0]     = (long *) calloc(gadget.no_gadget_files, sizeof(long *));
            gadget_.np[1]     = (long *) calloc(gadget.no_gadget_files, sizeof(long *));
            gadget_.np[2]     = (long *) calloc(gadget.no_gadget_files, sizeof(long *));
            gadget_.np[3]     = (long *) calloc(gadget.no_gadget_files, sizeof(long *));
            gadget_.np[4]     = (long *) calloc(gadget.no_gadget_files, sizeof(long *));
            gadget_.np[5]     = (long *) calloc(gadget.no_gadget_files, sizeof(long *));
            
            /* read multi-GADGET files one by one */
            for(i_gadget_file=0; i_gadget_file<no_gadget_files; i_gadget_file++)
            {
                sprintf(gadget_file,"%s.%d",infile_name,i_gadget_file);
                
                //DEBUG
                if(verbose_){
                    fprintf(stderr,"\n===================================================================\n");
                    fprintf(stderr,"=> reading %s\n\n",gadget_file);
                }
                    
                icfile = fopen(gadget_file,"rb");
                
                /* tell read_gadget() which file we are using at the moment */
                gadget_.i_gadget_file = i_gadget_file;
                
                /* read files... */
                read_gadget_header(icfile);
                fclose(icfile);
            }
            

        }
        else
        {
            /* there are no multi-GADGET files */
            fprintf(stderr,"\n\ninput: could not open file with IC's  %s\n",infile_name);
            exit(1);
        }
    }
    /*===============================
     * there is only one GADGET file
     *===============================*/
    else
    {
        gadget.no_gadget_files  = 1;
        gadget.i_gadget_file    = 0;
        
        /* allocate temporary storage for no. of particles arrays */
        gadget.np[0]     = (long *) calloc(gadget.no_gadget_files, sizeof(long *));
        gadget.np[1]     = (long *) calloc(gadget.no_gadget_files, sizeof(long *));
        gadget.np[2]     = (long *) calloc(gadget.no_gadget_files, sizeof(long *));
        gadget.np[3]     = (long *) calloc(gadget.no_gadget_files, sizeof(long *));
        gadget.np[4]     = (long *) calloc(gadget.no_gadget_files, sizeof(long *));
        gadget.np[5]     = (long *) calloc(gadget.no_gadget_files, sizeof(long *));
        
        read_gadget(icfile);
        fclose(icfile);

    }
    
    
    /* check the range of the IDs of "halo" particles */
    fprintf(stderr,"\nquick ID check:\n");
    fprintf(stderr,"   IDmin = %ld\n",IDmin);
    fprintf(stderr,"   IDmax = %ld\n",IDmax);
    fprintf(stderr,"   IDmax-IDmin = %ld  vs.  nall[1] = %d\n\n",IDmax-IDmin,gadget.header.nall[1]);
    //exit(0);
    
    /*=============================================================================
     *
     * this simple loop shows you how to use the particles now...
     *
     *
     * Pos[] is in Mpc/h    (comoving coordinate x)
     * Vel[] is in km/sec   (peculiar velocity \dot{a} x)
     * Mass  is in Msun/h
     * ID
     *
     *=============================================================================*/
    for(ipart=0; ipart<gadget.nall; ipart++)
    {
        fprintf(stderr,"%g %g %g   %g %g %g   %g   %ld\n",
                Part[ipart].Pos[X],Part[ipart].Pos[Y],Part[ipart].Pos[Z],
                Part[ipart].Vel[X],Part[ipart].Vel[Y],Part[ipart].Vel[Z],
                Part[ipart].Mass,
                Part[ipart].ID);
    }
    
}
