#include <vector>
#include <map>
#include <set>
#include <cstring>
#include <unordered_map>
#include "topK.h"

using namespace std;
/**
 * A grid cell
 */
class Cell{
    public:
        /* the following coordinate is the coordinate
         * of the bottom left corner.
         */
        Cell(double x, double y, double z, 
                double boxSize, double levelSize);
        Cell(int key, double boxSize, double levelSize);
        



        double x;
        double y;
        double z;

        double size;
        
        // the counts
        int count;

};


class HashFamily{
    
public:
    long long int familySize;
    long long int n;
    vector<long long int> aParams;
    vector<long long int> bParams;
    const long long int primeNumber = 39916801;
    void setHashFamily(long long int hashFamilySize, long long int range);
    int evalFunction(long long int x, long long int iFunction);
};

class CountSketch{
public:
    TopK topK;
    CountSketch(double levelSize, int totalParts, double boxSize,
                int b, int t, int k);
    
    void add(int key);
    int estimate(int key);
    void alg(double x, double y, double z);
    vector<vector<int> > getResult();
    ~CountSketch();
private:
    //priority_queue<pair<int,int>,vector<pair<int,int>>, compare> minHeap;
    int b_;
    int t_;
    int delta_;
    //int noParts_;
    int k_;
    int* countSketch;//Count Sketch
    HashFamily hashFamilyH;
    HashFamily hashFamilyS;

    double levelSize_;
    int totalParts_;
    double phobar_; // average density
    double boxSize_;
    double densConst_;
    double sampleProbability_;
    int minNumCellParts_;  // min number of particles in this cell
    int maxNumCellParts_;  // max number of particles in this cell
    int trueNumParts_; // the true number of particles in this cell
    
    int getCell_(double x, double y, double z);
    void updateTopKMin();
};

