#include "pickdrop.h"
#include <cmath>
#include <iostream>
#include <utility>
#include <algorithm>
#include <random>

using namespace std;


PickDrop::PickDrop(int _t, double _lembda, int _keysize, int _nR, int _seed){
    
    keysize = _keysize;
    t= _t;
    nR = _nR;
    lembda = _lembda;
    i = 1;
    prevM= -10000;
    counter=0;//The counter for the recevied data
    f_counter=0;//The counter for calculating f_l,i
    range=0;//The range of the input data
    
    mt19937 rand(_seed);
    //uniform_int_distribution<int> distribution(1,t);
    ranIs = new int[nR];
    //printf("*********** %d \n", _seed);
    for (int iR = 0; iR< nR; iR++) {
        int tmp = rand()%t+1;
        //printf("#####%d \n", tmp);
        ranIs[iR] = tmp;
    }
    

}

//PickDrop::~PickDrop()
//{
//    delete [] ranIs;
//}

void PickDrop::Add(int _p)
{
    p=_p;
    counter++;
    i = ceil((double)counter/t);

    if(p>range)
        range = p;//record the largest key
    //Judge the row ID and get random I[]
    if (counter == 1) {
        ran_I = ranIs[0];
    }
    
    
    if(p==prevM){
        
        f_counter++;
        
    }
    int ranPos = ((i-1)*t)+ran_I;
    //printf("i is %d, Random is %d, t is %d the I postion is %d \n", i, ran_I,t, ranPos);
    //When read m_i,j from data stream
    if(counter == ranPos){
        
        currentM = p;
        //m.push_back(p);
        //cout << "The m("<<i<<","<<ran_I<<")="<<currentM<<endl;
        d_counter = 1;
    }
    
    if ((counter > ranPos) && p==currentM)
        d_counter++;
    
    if (counter == i*t) {
        ran_I = ranIs[i];//resample I
        //printf("The randomed I is %d \n",ran_I);
        F.push_back(f_counter);// Compute f
        //f_counter = 0;
        
        if(i==1){
            prevM = currentM;
            q.push_back(1);
            C.push_back(d_counter);
            S.push_back(currentM);
            
        }else
        {
            int s_i = currentM;
            int c_i = d_counter;
            
            if (C[i-2] < max(lembda*(double)q[i-2], (double)c_i)) {
            S.push_back(s_i);
            C.push_back(c_i);
            q.push_back(1);
            prevM = s_i;
        }
        else{
            S.push_back(S[i-2]);
            C.push_back(C[i-2] + F[i-2]);
            q.push_back(q[i-2]+1);
            //prevM = S[i-2];
        }
    }
        f_counter = 0;
    }
    
}

vector<int> PickDrop::PD(){
    r = S.size();
    //printf("************ %d counters \n",counter);
    int key = S[r-1];
    int ix = (key % (keysize*keysize)) % keysize;
    int iy = (key % (keysize*keysize)) / keysize;
    int iz = (key / (keysize*keysize));
    vector<int> output = {ix, iy, iz, C[r-1]};
    
    //printf("\n The Total Data Stream Size is %d with the range from 1 to %d \n", counter,range);
    
    printf("The output(x,y,z,Cr) is: %d,%d,%d, %d\n",ix,iy,iz,C[r-1]);
    return output;
    
}

vector<int> PickDrop::PD2(){
    
    r = S.size();
    vector<int> output = {S[r-1], C[r-1]};
    
    return output;
    
}

