#include "topK.h"
using namespace std;

void TopK::printTopKcounters(){
    cout << "------------------------" << endl;
    for (int i = 0; i < (int) topKcounters.size(); ++i) {
        cout << topKcounters[i].first << " " << topKcounters[i].second << endl;
    }
}

vector<pair<long int,int> > TopK::getTopKcounters(){
    return topKcounters;
}

void TopK::setK(int k_){
    k = k_;
}


bool TopK::isFull(){
    return ((int)topKcounters.size() >= k);
}

bool TopK::hasMember(long int key){
    unordered_map<long int, int>::const_iterator got = topKindices.find(key);
    return (got!=topKindices.end());
}


int TopK::getMinCounter(){
    return topKcounters.back().second;
}


void TopK::insert(long int key, int counter){
    if (isFull()) {
        topKindices.erase(topKcounters.back().first);
        topKcounters.back().first = key;
        topKcounters.back().second = counter;
    }else{
        topKcounters.push_back(pair<long int, int>(key,counter));
    }
    topKindices[key] = topKcounters.size() - 1;
    updateOrder((int) (topKcounters.size() - 1));

}

void TopK::increment(long int key){
    topKcounters[topKindices[key]].second ++;
    updateOrder(topKindices[key]);
}

void TopK::updateOrder(int changedIdx){
    while ((changedIdx > 0) && (topKcounters[changedIdx].second > topKcounters[changedIdx - 1].second)){
        swap(topKindices[topKcounters[changedIdx].first], topKindices[topKcounters[changedIdx - 1].first]);
        swap(topKcounters[changedIdx], topKcounters[changedIdx - 1]);
        changedIdx --;
    }
}