#ifndef __LY__GADSIMPLEREADER
#define __LY__GADSIMPLEREADER
#include <string>
#include <vector>
#include <cstdio>

#include "gadgetheader.h"


class Particle
{
public:
    float     Pos[3];       /* particle position   */
    float     Vel[3];       /* particle velocity   */
    long      ID;
};


class GadgetSimpleReader{
public:
    
    // get the header of the file
    gadget_header getHeader(std::string filename,
                                   int format = 1,
                                   bool swap = true,
                                   bool lgadget = true,
                                   bool verbose = false);
    
    
    // read a single file, load all the particles into RAM
    // read all particle types
    std::vector<Particle> getParticle(std::string filename,
                                             int format = 1,
                                             bool swap = true,
                                             bool lgadget = true,
                                             bool verbose = false);
    
private:
    void readHeader(std::FILE* icfile, gadget_header & header);
    void readData(std::FILE* icfile, gadget_header & header, std::vector<Particle> & particles);
    
};

#endif
